@echo off
setlocal

:main
	call :setenv
	
	call :build gtk000
	call :build gtk001
	call :build gtk002
	
	goto :eof

:build
	setlocal
	set TARGET=%~1
	set OPTIONS=%OPTIONS% /noconfig
	set OPTIONS=%OPTIONS% /nologo
	set OPTIONS=%OPTIONS% /nowarn:1701,1702
	set OPTIONS=%OPTIONS% /errorreport:prompt
	set OPTIONS=%OPTIONS% /warn:4
	set OPTIONS=%OPTIONS% /define:DEBUG;TRACE
	set OPTIONS=%OPTIONS% %REFERENCE%
	rem set OPTIONS=%OPTIONS% /debug+
	rem set OPTIONS=%OPTIONS% /debug:full
	rem set OPTIONS=%OPTIONS% /optimize-
	set OPTIONS=%OPTIONS% /out:"%TARGETDIR%%TARGET%.exe"
	set OPTIONS=%OPTIONS% /target:winexe
	
	set SOURCEDIR=%~dp0%TARGET%\
	set SOURCES=%SOURCES% "%SOURCEDIR%Program.cs"
	
	echo %TARGET% >&2
	csc %OPTIONS% %SOURCES%
	
	goto :eof

:setenv
	call "%VS80COMNTOOLS%vsvars32.bat"
	
	set GTKSHARP=%GTK_BASEPATH%lib\gtk-sharp-2.0\
	set CAIRO=%GTK_BASEPATH%lib2\Mono.Cairo\
	
	set REFERENCE=%REFERENCE% /reference:"%GTKSHARP%atk\atk-sharp.dll"
	set REFERENCE=%REFERENCE% /reference:"%GTKSHARP%glib\glib-sharp.dll"
	set REFERENCE=%REFERENCE% /reference:"%GTKSHARP%gtk\gtk-sharp.dll"
	set REFERENCE=%REFERENCE% /reference:"%GTKSHARP%gtk-dotnet\gtk-dotnet.dll"
	set REFERENCE=%REFERENCE% /reference:"%GTKSHARP%gdk\gdk-sharp.dll"
	set REFERENCE=%REFERENCE% /reference:"%GTKSHARP%glade\glade-sharp.dll"
	set REFERENCE=%REFERENCE% /reference:"%GTKSHARP%pango\pango-sharp.dll"
	set REFERENCE=%REFERENCE% /reference:"%GTKSHARP%vte\vte-sharp.dll"
	set REFERENCE=%REFERENCE% /reference:"%CAIRO%Mono.Cairo.dll"
	set REFERENCE=%REFERENCE% /reference:System.Data.dll
	set REFERENCE=%REFERENCE% /reference:System.Deployment.dll
	set REFERENCE=%REFERENCE% /reference:System.dll
	set REFERENCE=%REFERENCE% /reference:System.Drawing.dll
	set REFERENCE=%REFERENCE% /reference:System.Windows.Forms.dll
	set REFERENCE=%REFERENCE% /reference:System.Xml.dll
	
	set TARGETDIR=%~dp0bin\
	if not exist "%TARGETDIR%" (
		mkdir "%TARGETDIR%"
	)
	goto :eof

