//	shive's code 2008.08.19
//=============================================================================

#pragma once
#include "../com/util.h"

namespace shive {
	namespace scp {
		class vmapi;
		class vmthread;
	}
	namespace fwk {
		class Loader;
		class World;
	}
}

namespace shive { namespace hoge {

	//foCX
	struct device {
		device();
		~device();
		operator IDirect3DDevice9* () const;
		IDirect3DDevice9* operator -> () const;
	};

	//EBhE
	struct window {
		window();
		~window();
		operator HWND () const;
		float aspect() const;
	};

	class Grid;
	class Camera;

	class App : public singleton<App> {
	public:
		App();
		~App();

		//
		bool init();
		//I
		void term();

		//`揈
		void draw();
		//XViƗXbhĂ΂j
		bool update( com::tick delta );

		//}EX
		bool OnMouseMove( uint buttons, const POINT& mpt );

	private:
		void initvm( scp::vmapi& vmc );

	private:
		smptr<scp::vmthread> mainthread_;
		smptr<fwk::Loader> loader_;
		smptr<fwk::World> world_;
		smptr<Camera> camera_;
		smptr<Grid> grid_;
	};

}}
