//	shive's code 2008.09.08
//=============================================================================

#pragma once

namespace shive { namespace scp { namespace detail {

	static inline const char* gettypeflag( bool* ) { return "b"; }
	static inline const char* gettypeflag( int* ) { return "i|f"; }
	static inline const char* gettypeflag( float* ) { return "i|f"; }
	static inline const char* gettypeflag( const char** ) { return "s"; }
	static inline const char* gettypeflag( vmobj* ) { return "."; }
	template<typename U> static inline const char* gettypeflag( U* ) { return "x|o"; }

#define TYPEFLAG(N) (gettypeflag((tt<_##N>::x*)0))

	template<typename T>
	struct tt {
		typedef T x;
	};
	template<typename T>
	struct tt<T*> {
		typedef T x;
	};
	template<typename T>
	struct tt<T&> {
		typedef T x;
	};
	template<typename T>
	struct tt<const T> {
		typedef T x;
	};
	template<typename T>
	struct tt<const T*> {
		typedef T x;
	};
	template<typename T>
	struct tt<const T&> {
		typedef T x;
	};
	template<>
	struct tt<const char*> {
		typedef const char* x;
	};

	template<typename T>
	struct functrait;

	template<typename R>
	struct functrait<R(*)()> {
		typedef R(*type)();
		typedef R result;
		static const int narg = 0;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"t");
			return tm;
		}
	};
	template<typename R,typename _0>
	struct functrait<R(*)(_0)> {
		typedef R(*type)(_0);
		typedef R result;
		typedef _0 arg0;
		static const int narg = 1;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"t");
			strcat(tm.s,TYPEFLAG(0));
			return tm;
		}
	};
	template<typename R,typename _0,typename _1>
	struct functrait<R(*)(_0,_1)> {
		typedef R(*type)(_0,_1);
		typedef R result;
		typedef _0 arg0;
		typedef _1 arg1;
		static const int narg = 2;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"t");
			strcat(tm.s,TYPEFLAG(0));
			strcat(tm.s,TYPEFLAG(1));
			return tm;
		}
	};
	template<typename R,typename _0,typename _1,typename _2>
	struct functrait<R(*)(_0,_1,_2)> {
		typedef R(*type)(_0,_1,_2);
		typedef R result;
		typedef _0 arg0;
		typedef _1 arg1;
		typedef _2 arg2;
		static const int narg = 3;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"t");
			strcat(tm.s,TYPEFLAG(0));
			strcat(tm.s,TYPEFLAG(1));
			strcat(tm.s,TYPEFLAG(2));
			return tm;
		}
	};
	template<typename R,typename _0,typename _1,typename _2,typename _3>
	struct functrait<R(*)(_0,_1,_2,_3)> {
		typedef R(*type)(_0,_1,_2,_3);
		typedef R result;
		typedef _0 arg0;
		typedef _1 arg1;
		typedef _2 arg2;
		typedef _3 arg3;
		static const int narg = 4;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"t");
			strcat(tm.s,TYPEFLAG(0));
			strcat(tm.s,TYPEFLAG(1));
			strcat(tm.s,TYPEFLAG(2));
			strcat(tm.s,TYPEFLAG(3));
			return tm;
		}
	};
	template<typename R,typename _0,typename _1,typename _2,typename _3,typename _4>
	struct functrait<R(*)(_0,_1,_2,_3,_4)> {
		typedef R(*type)(_0,_1,_2,_3,_4);
		typedef R result;
		typedef _0 arg0;
		typedef _1 arg1;
		typedef _2 arg2;
		typedef _3 arg3;
		typedef _4 arg4;
		static const int narg = 5;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"t");
			strcat(tm.s,TYPEFLAG(0));
			strcat(tm.s,TYPEFLAG(1));
			strcat(tm.s,TYPEFLAG(2));
			strcat(tm.s,TYPEFLAG(3));
			strcat(tm.s,TYPEFLAG(4));
			return tm;
		}
	};

	template<typename T,typename R>
	struct functrait<R(T::*)()> {
		typedef R(T::*type)();
		typedef R result;
		static const int narg = 0;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"x");
			return tm;
		}
	};
	template<typename T,typename R,typename _0>
	struct functrait<R(T::*)(_0)> {
		typedef R(T::*type)(_0);
		typedef R result;
		typedef _0 arg0;
		static const int narg = 1;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"x");
			strcat(tm.s,TYPEFLAG(0));
			return tm;
		}
	};
	template<typename T,typename R,typename _0,typename _1>
	struct functrait<R(T::*)(_0,_1)> {
		typedef R(T::*type)(_0,_1);
		typedef R result;
		typedef _0 arg0;
		typedef _1 arg1;
		static const int narg = 2;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"x");
			strcat(tm.s,TYPEFLAG(0));
			strcat(tm.s,TYPEFLAG(1));
			return tm;
		}
	};
	template<typename T,typename R,typename _0,typename _1,typename _2>
	struct functrait<R(T::*)(_0,_1,_2)> {
		typedef R(T::*type)(_0,_1,_2);
		typedef R result;
		typedef _0 arg0;
		typedef _1 arg1;
		typedef _2 arg2;
		static const int narg = 3;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"x");
			strcat(tm.s,TYPEFLAG(0));
			strcat(tm.s,TYPEFLAG(1));
			strcat(tm.s,TYPEFLAG(2));
			return tm;
		}
	};
	template<typename T,typename R,typename _0,typename _1,typename _2,typename _3>
	struct functrait<R(T::*)(_0,_1,_2,_3)> {
		typedef R(T::*type)(_0,_1,_2,_3);
		typedef R result;
		typedef _0 arg0;
		typedef _1 arg1;
		typedef _2 arg2;
		typedef _3 arg3;
		static const int narg = 4;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"x");
			strcat(tm.s,TYPEFLAG(0));
			strcat(tm.s,TYPEFLAG(1));
			strcat(tm.s,TYPEFLAG(2));
			strcat(tm.s,TYPEFLAG(3));
			return tm;
		}
	};
	template<typename T,typename R,typename _0,typename _1,typename _2,typename _3,typename _4>
	struct functrait<R(T::*)(_0,_1,_2,_3,_4)> {
		typedef R(T::*type)(_0,_1,_2,_3,_4);
		typedef R result;
		typedef _0 arg0;
		typedef _1 arg1;
		typedef _2 arg2;
		typedef _3 arg3;
		typedef _4 arg4;
		static const int narg = 5;
		struct typemask_t {
			char s[ narg * 3 + 2 ];
		};
		static typemask_t gettypemask() {
			typemask_t tm = {'\0'};
			strcat(tm.s,"x");
			strcat(tm.s,TYPEFLAG(0));
			strcat(tm.s,TYPEFLAG(1));
			strcat(tm.s,TYPEFLAG(2));
			strcat(tm.s,TYPEFLAG(3));
			strcat(tm.s,TYPEFLAG(4));
			return tm;
		}
	};

	template<typename T,typename R>
	struct functrait<R(T::*)() const> : functrait<R(T::*)()>
	{
		typedef R(T::*type)() const;
	};
	template<typename T,typename R,typename _0>
	struct functrait<R(T::*)(_0) const> : functrait<R(T::*)(_0)>
	{
		typedef R(T::*type)(_0) const;
	};
	template<typename T,typename R,typename _0,typename _1>
	struct functrait<R(T::*)(_0,_1) const> : functrait<R(T::*)(_0,_1)>
	{
		typedef R(T::*type)(_0,_1) const;
	};
	template<typename T,typename R,typename _0,typename _1,typename _2>
	struct functrait<R(T::*)(_0,_1,_2) const> : functrait<R(T::*)(_0,_1,_2)>
	{
		typedef R(T::*type)(_0,_1,_2) const;
	};

#undef TYPEFLAG

}}}
