//	shive's code 2008.09.15
//=============================================================================

#pragma once
#include "../types.h"
#include <assert.h>

#ifdef _DEBUG
#	define _(C) (assert(C))
#else
#	define _(C) (C)
#endif

namespace shive { namespace scp { namespace detail {

	//Sf[^Rs[
	template<typename U>
	static inline void ret_set_deepcopy( HSQUIRRELVM hvm, const typename tt<U>::x& value ) {
		vmapi vm(hvm);
		creg_link_holder<tt<U>::x>::_pushclass(vm);
		vm.createinstance();
		U* p = static_cast<U*>(vm.getinstanceup(-1,creg_link_holder<tt<U>::x>::_typetag()));
		_(p);
		*p = value;
		vm.remove(-2);
	}
	//|C^݂̂Rs[
	template<typename U>
	static inline void ret_set_ptr( HSQUIRRELVM hvm, const typename tt<U>::x& value ) {
		vmapi vm(hvm);
		creg_link_holder<tt<U>::x>::_pushclass(vm);
		vm.createinstance();
		vm.setinstanceup(-1,(void*)&value);
		vm.remove(-2);
	}

	template<typename U>
	struct ret {
		static void set( HSQUIRRELVM hvm, U value ) {
			ret_set_deepcopy<U>(hvm,value);
		}
	};
	template<>
	struct ret<const char*> {
		static void set( HSQUIRRELVM hvm, const char* value ) {
			if(value){
				vmapi(hvm).pushstring(value);
			}
			else{
				vmapi(hvm).pushnull();
			}
		}
	};
	template<>
	struct ret<int> {
		static void set( HSQUIRRELVM hvm, int value ) {
			vmapi(hvm).pushinteger(value);
		}
	};
	template<>
	struct ret<float> {
		static void set( HSQUIRRELVM hvm, float value ) {
			vmapi(hvm).pushfloat(value);
		}
	};
	template<>
	struct ret<bool> {
		static void set( HSQUIRRELVM hvm, bool value ) {
			vmapi(hvm).pushbool(value);
		}
	};
	template<>
	struct ret<vmobj> {
		static void set( HSQUIRRELVM hvm, vmobj value ) {
			vmapi(hvm).pushobject(value);
		}
	};
	template<>
	struct ret<vmobj&> {
		static void set( HSQUIRRELVM hvm, vmobj& value ) {
			vmapi(hvm).pushobject(value);
		}
	};
	template<typename U>
	struct ret<U*> {
		static void set( HSQUIRRELVM hvm, U* value ) {
			if(value){
				ret<U&>::set(hvm,*value);
			}
			else{
				vmapi(hvm).pushnull();
			}
		}
	};
	template<typename U>
	struct ret<U&> {
		static void set( HSQUIRRELVM hvm, U& value ) {
			ret_set_ptr<U>(hvm,value);
		}
	};
	/*
	template<typename U>
	struct ret< objptr<U> > {
		static void set( HSQUIRRELVM hvm, objptr<U>& value ) {
			U* p = value.get();
			if(p){incref(p);}
			ret<U*>::set(hvm,p);
		}
	};
	*/

}}}

#undef _
