//	shive's code 2008.09.06
//=============================================================================

#include "stdafx.h"
#include "test001.h"

static void* operator new ( size_t, void* ptr ) {
	return ptr;
}

static void printcallback( HSQUIRRELVM hvm, const SQChar* format, ... ) {
	va_list args;
	va_start( args, format );
	vprintf_s( format, args );
	va_end( args );
}

class aaa {
public:
	aaa() {
		strcpy(name,"aaa");
	}
	void somemsg() {
		printf("my name is %s\n",name);
	}
	const char* getname() const {
		return name;
	}
	void setname( const char* _name ) {
		strcpy(name,_name);
	}
	float add( float a, float b ) {
		return a + b;
	}
	static int getstatic() {
		static int s_counter = 0;
		return s_counter++;
	}
	char name[256];
};

int main( int, const char** )
{
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	
	HSQUIRRELVM hvm = sq_open(1024);
	sq_setprintfunc(hvm,&printcallback);
	_(sqstd_register_iolib(hvm));
	_(sqstd_register_stringlib(hvm));
	
	//NXo^
	creg<aaa>(hvm,"aaa")
		.function("getstatic",&aaa::getstatic)
		.function("somemsg",&aaa::somemsg)
		.function("getname",&aaa::getname)
		.function("setname",&aaa::setname)
		.function("add",&aaa::add)
		.variable("name",&aaa::getname,&aaa::setname)
		.constant("constant_string","\\\")
		.constant("constant_integer",111)
		.constant("constant_float",0.99f)
		;
	
	//XNvgĂяoĂ݂
	sq_pushroottable(hvm);
	_(sqstd_dofile(hvm,"test001.nut",true,true));
	
	sq_close(hvm);
	return 0;
}

