
struct VS_INPUT
{
	float3 pos : POSITION;
//	float3 nor : NORMAL;
	float4 col : COLOR0;
	float2 uv : TEXCOORD0;
};
struct VS_OUTPUT
{
	float4 vpos : POSITION;
	float4 col : COLOR0;
	float2 uv : TEXCOORD0;
};

float4x4 g_wvp : register(c8);

VS_OUTPUT vsmain( VS_INPUT vsi )
{
	VS_OUTPUT vso = (VS_OUTPUT)0;
	
	vso.vpos = mul(g_wvp,float4(vsi.pos,1));
	vso.col = vsi.col;
	vso.uv = vsi.uv;
	
	return vso;
}

sampler2D g_sampler;

float4 psmain( VS_OUTPUT vso ) : COLOR0
{
	return tex2D( g_sampler, vso.uv ) * vso.col;
}

