#pragma once
#include "../Object.h"

namespace seg { namespace dgr {

	class Context;

	class SEGEXPORT Shader : public Object
	{
	public:
		Shader( IDirect3DVertexShader9* vsh, IDirect3DPixelShader9* psh )
		{
			this->vsh_ = vsh;
			this->psh_ = psh;
		}
		virtual ~Shader()
		{
			if( this->vsh_ ){
				this->vsh_->Release();
				this->vsh_ = 0;
			}
			if( this->psh_ ){
				this->psh_->Release();
				this->psh_ = 0;
			}
		}

	private:
		IDirect3DVertexShader9* vsh_;
		IDirect3DPixelShader9* psh_;

		friend class Context;
	};

}}
