
#include "test.h"
#include <stdio.h>

void hello( message func )
{
	printf("func = 0x%08X\n",(uintptr_t)func);
	printf("hello!! %s\n",(*func)());
}

static const char* msg_unmanaged()
{
	return "I'm unmanaged!!";
}
void hello2()
{
	hello(msg_unmanaged);
}

Human* Human::New()
{
	return new Human();
}
void Human::Delete( Human* p )
{
	delete p;
}
Human::Human()
{
	strcpy_s(this->name_,"noname");
}
Human::~Human()
{
}
void Human::Greeting()
{
	printf("I'm Human!! my name is %s\n",this->name_);
}

static message s_fn = 0;
void setmessage( message func )
{
	s_fn = func;
}
void say()
{
	printf("%s\n",(*s_fn)());
}
