#pragma once

#include <string.h>

#ifndef DLLEXPORT
# define DLLEXPORT __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef const char* (*message)();
DLLEXPORT void hello( message func );
DLLEXPORT void hello2();

DLLEXPORT void setmessage( message func );
DLLEXPORT void say();


#ifdef __cplusplus
}
#endif

DLLEXPORT void Greeting(){}

class DLLEXPORT Human
{
public:
	static Human* New();
	static void Delete( Human* p );

public:
	Human();
	~Human();

	void SetName( const char* name ) {
		strcpy_s(this->name_,name);
	}
	void Greeting();

private:
	void operator=(const Human&);

	char name_[32];
};
