
#include <stdio.h>
#include "lib.h"
#include "libB.h"

extern "C" char lib_buf[ 256 ] = "ybzCUCu";
extern "C" char libB_buf[ 256 ] = "ʃwb_";
char lib::lib_buf_cpp[ 256 ] = "yb{{zCUCu";

extern "C" void lib_func()
{
	printf("call lib_func()\n");
}
extern "C" void lib_func2()
{
	printf("call lib_func2()\n");
}
void lib_func3()
{
	printf("call lib_func3()\n");
}

std::auto_ptr<lib::lib_class> lib::lib_class::s_singleton;

lib::lib_class::lib_class()
{
	printf("call lib_class.ctor\n");

	lib_class::s_singleton.release();
	lib_class::s_singleton.reset(this);
}
lib::lib_class::~lib_class()
{
	printf("call lib_class.dtor\n");
	lib_class::s_singleton.release();
}
void lib::lib_class::func()
{
	printf("call lib_class.func()\n");
}

extern "C" int lib_lib_obj = 0;
