//	shive's code 2008.08.19
//=============================================================================

#pragma once
#include "../fwk/Model.h"
#include "../com/util.h"

namespace shive { namespace hoge {

	//foCX
	struct device {
		device();
		~device();
		operator IDirect3DDevice9* () const;
		IDirect3DDevice9* operator -> () const;
	};

	//EBhE
	struct window {
		window();
		~window();
		operator HWND () const;
		float aspect() const;
	};

	class Grid;
	class Camera;

	class App : public singleton<App> {
	public:
		App();
		~App();

		//
		uint init( uint );
		//I
		void term();

		//`揈
		void draw();
		//XViƗXbhĂ΂j
		bool update( com::tick delta );

		//}EX
		bool OnMouseMove( uint buttons, const POINT& mpt );

	private:
		objptr<fwk::World> world_;
		objptr<Camera> camera_;
		objptr<Grid> grid_;
	};

}}
