//	shive's code 2008.09.06
//=============================================================================

#include "stdafx.h"

#define _(code) assert(SQ_SUCCEEDED(code))
#define SQCODE(hvm,code) hvm.dostring(#code)

static void* operator new ( size_t, void* ptr ) {
	return ptr;
}

static void printcallback( HSQUIRRELVM hvm, const SQChar* format, ... ) {
	va_list args;
	va_start( args, format );
	vprintf_s( format, args );
	va_end( args );
}

class aaa {
public:
	aaa() {
		strcpy(name,"aaa");
		printf("aaa::aaa()\n",name);
	}
	void somemsg() {
		printf("my name is %s\n",name);
	}
private:
	char name[256];
};

template<typename T>
class creg {
public:
	explicit creg( HSQUIRRELVM _hvm ) : hvm(_hvm)
	{
		_(sq_newclass(hvm,false));
		_(sq_setclassudsize(hvm,-1,sizeof(T)));
		
		sq_pushstring(hvm,"constructor",-1);
		sq_newclosure(hvm,&constructor,0);
		_(sq_newslot(hvm,-3,false));
	}
	
	creg& function( const char* name, void (T::*fn)() )
	{
		sq_pushstring(hvm,name,-1);
		sq_pushuserpointer(hvm,*(void**)&fn);
		sq_newclosure(hvm,&call_v_v,1);
		_(sq_newslot(hvm,-3,false));
		return (*this);
	}
	
private:
	//constructor
	static int constructor( HSQUIRRELVM hvm )
	{
		T* p = 0;
		_(sq_getinstanceup(hvm,1,(SQUserPointer*)&p,0));
		new(p) T();
		return 0;
	}
	//void (T::*fn)()
	static int call_v_v( HSQUIRRELVM hvm )
	{
		T* p = 0;
		_(sq_getinstanceup(hvm,1,(SQUserPointer*)&p,0));
		
		void (T::*fn)() = 0;
		sq_getuserpointer(hvm,-1,(void**)&fn);
		
		(p->*fn)();
		
		return 0;
	}
	
private:
	HSQUIRRELVM hvm;
};

int main( int, const char** )
{
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	
	HSQUIRRELVM hvm = sq_open(1024);
	sq_setprintfunc(hvm,&printcallback);
	_(sqstd_register_iolib(hvm));
	_(sqstd_register_stringlib(hvm));
	
	//NXo^
	sq_pushroottable(hvm);
	sq_pushstring(hvm,"aaa",-1);
	creg<aaa>(hvm)
		.function("somemsg",&aaa::somemsg);
	_(sq_newslot(hvm,-3,false));
	
	//XNvgĂяoĂ݂
	sq_pushroottable(hvm);
	_(sqstd_dofile(hvm,"test001.nut",true,true));
	
	sq_close(hvm);
	return 0;
}

