﻿//	shive's code 2009.01.09
//=============================================================================

using System;
using Gtk;

namespace gtk001
{
	static class Program
	{
		static void Main()
		{
			Application.Init();

			//メインウィンドウ
			Window window = new Window(AppDomain.CurrentDomain.FriendlyName.Split('.')[0]);
			window.SetDefaultSize(350,300);
			window.BorderWidth = 0;
			window.Destroyed += delegate( object sender, EventArgs args ){
				Application.Quit();
			};
			window.DeleteEvent += delegate( object sender, DeleteEventArgs args ){
				window.Destroy();
			};
			window.KeyPressEvent += delegate( object sender, KeyPressEventArgs args ){
				if( args.Event.Key == Gdk.Key.Escape ){
					window.Destroy();
				}
			};

			VBox box = new VBox(false,5);
			window.Add(box);

			//メニュー
			{
				MenuBar menubar = new MenuBar();
				MenuItem item = new MenuItem("File");
				menubar.Append(item);
				Menu menu = new Menu();
				MenuItem exit = new MenuItem("Exit");
				exit.Activated += delegate( object sender, EventArgs args ){
					window.Destroy();
				};
				menu.Append(exit);
				item.Submenu = menu;
				box.PackStart(menubar,false,false,0);
			}

			//ボタン
			{
				Button button = new Button("ボタン");
				button.TooltipMarkup = "<u><i>押してみて～</i></u>";//マークアップ
				button.Clicked += delegate( object sender, EventArgs args ){
					using(MessageDialog msgbox = new MessageDialog(window,DialogFlags.NoSeparator,MessageType.Other,ButtonsType.YesNo,"MessageDialog!!")){
						msgbox.Title = "じーてーけー";
						msgbox.Run();
						msgbox.Destroy();
					}
				};

				box.PackStart(button);
				box.PackStart(new Button("1"));
				box.PackStart(new Button("2"));
				box.PackStart(new Button("3"));
				box.PackStart(new Button("4"));
				box.PackStart(new Button("5"));
		}

			window.ShowAll();
			Application.Run();
		}
	}
}
