//	shive's code 2008.09.08
//=============================================================================

template<typename X>
struct fn;

#define THISCALL(FUNC)										\
	struct fn<FUNC> {										\
		typedef typename functrait<FUNC>::type type;		\
		static const int S = sizeof(type)/sizeof(int);		\
		static int call( HSQUIRRELVM hvm ) {				\
			vmapi vm(hvm);									\
			T* p = (T*)vm.getinstanceup(1,_typetag());		\
			union{ type f; int n[S]; };						\
			for(int Li=1;Li<=S;++Li){n[Li-1]=vm.getinteger(-Li);}\
			return call_and_return(hvm,f,p);				\
		}													\
	}
#define STATICCALL(FUNC)								\
	struct fn<FUNC> {									\
		typedef typename functrait<FUNC>::type type;	\
		static int call( HSQUIRRELVM hvm ) {			\
			vmapi vm(hvm);								\
			union{ type f; int n; };					\
			n = vm.getinteger();						\
			return call_and_return(hvm,f);				\
		}												\
	}

#define DECL_ARG0 ()
#define DECL_ARG1 (_0)
#define DECL_ARG2 (_0,_1)
#define DECL_ARG3 (_0,_1,_2)
#define DECL_ARG4 (_0,_1,_2,_3)
#define DECL_ARG5 (_0,_1,_2,_3,_4)

#define GET_ARGX(N) arg<_##N>::get(hvm,N)
#define GET_ARG0 ()
#define GET_ARG1 (GET_ARGX(0))
#define GET_ARG2 (GET_ARGX(0),GET_ARGX(1))
#define GET_ARG3 (GET_ARGX(0),GET_ARGX(1),GET_ARGX(2))
#define GET_ARG4 (GET_ARGX(0),GET_ARGX(1),GET_ARGX(2),GET_ARGX(3))
#define GET_ARG5 (GET_ARGX(0),GET_ARGX(1),GET_ARGX(2),GET_ARGX(3),GET_ARGX(4))

#define TMPL_V_ARG0
#define TMPL_V_ARG1 template<typename _0>
#define TMPL_V_ARG2 template<typename _0,typename _1>
#define TMPL_V_ARG3 template<typename _0,typename _1,typename _2>
#define TMPL_V_ARG4 template<typename _0,typename _1,typename _2,typename _3>
#define TMPL_V_ARG5 template<typename _0,typename _1,typename _2,typename _3,typename _4>

#define TMPL_R_ARG0 template<typename R>
#define TMPL_R_ARG1 template<typename R,typename _0>
#define TMPL_R_ARG2 template<typename R,typename _0,typename _1>
#define TMPL_R_ARG3 template<typename R,typename _0,typename _1,typename _2>
#define TMPL_R_ARG4 template<typename R,typename _0,typename _1,typename _2,typename _3>
#define TMPL_R_ARG5 template<typename R,typename _0,typename _1,typename _2,typename _3,typename _4>

#define TMPL_ARGX(N)\
	TMPL_V_ARG##N static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG##N, T* p ) {\
		(void)hvm; ((p->*f)GET_ARG##N); return 0; }\
	TMPL_V_ARG##N static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG##N const, T* p ) {\
		(void)hvm; ((p->*f)GET_ARG##N); return 0; }\
	TMPL_V_ARG##N static int call_and_return( HSQUIRRELVM hvm, void(*f)DECL_ARG##N ) {\
		(void)hvm; (*f)GET_ARG##N; return 0; }\
	TMPL_R_ARG##N static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG##N, T* p ) {\
		ret<R>::set(hvm,(p->*f)GET_ARG##N); return 1; }\
	TMPL_R_ARG##N static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG##N const, T* p ) {\
		ret<R>::set(hvm,(p->*f)GET_ARG##N); return 1; }\
	TMPL_R_ARG##N static int call_and_return( HSQUIRRELVM hvm, R(*f)DECL_ARG##N ) {\
		ret<R>::set(hvm,(*f)GET_ARG##N); return 1; }\
	TMPL_R_ARG##N THISCALL(R(T::*)DECL_ARG##N);\
	TMPL_R_ARG##N THISCALL(R(T::*)DECL_ARG##N const);\
	TMPL_R_ARG##N STATICCALL(R(*)DECL_ARG##N);

TMPL_ARGX(0)
TMPL_ARGX(1)
TMPL_ARGX(2)
TMPL_ARGX(3)
TMPL_ARGX(4)
TMPL_ARGX(5)

#undef TMPL_ARGX

#undef THISCALL
#undef STATICCALL

#undef DECL_ARG0
#undef DECL_ARG1
#undef DECL_ARG2
#undef DECL_ARG3

#undef GET_ARGX
#undef GET_ARG0
#undef GET_ARG1
#undef GET_ARG2
#undef GET_ARG3

#undef TMPL_V_ARG0
#undef TMPL_V_ARG1
#undef TMPL_V_ARG2
#undef TMPL_V_ARG3

#undef TMPL_R_ARG0
#undef TMPL_R_ARG1
#undef TMPL_R_ARG2
#undef TMPL_R_ARG3
