//	shive's code 2008.09.08
//=============================================================================

#ifndef FUNCTRAIT_H_INCLUDED
#define FUNCTRAIT_H_INCLUDED

static char gettypeflag( bool* ) { return 'b'; }
static char gettypeflag( int* ) { return 'i'; }
static char gettypeflag( float* ) { return 'f'; }
static char gettypeflag( const char** ) { return 's'; }

template<typename T>
struct functrait;

template<typename R>
struct functrait<R(*)()> {
	typedef R(*type)();
	typedef R result;
	static const int narg = 0;
	struct typemask_t {
		char s[ narg + 2 ];
	};
	static typemask_t gettypemask() {
		typemask_t tm = {'t','\0'};
		return tm;
	}
};
template<typename R,typename _0>
struct functrait<R(*)(_0)> {
	typedef R(*type)(_0);
	typedef R result;
	typedef _0 arg0;
	static const int narg = 1;
	struct typemask_t {
		char s[ narg + 2 ];
	};
	static typemask_t gettypemask() {
		typemask_t tm = {'t',gettypeflag((_0*)0),'\0'};
		return tm;
	}
};
template<typename R,typename _0,typename _1>
struct functrait<R(*)(_0,_1)> {
	typedef R(*type)(_0,_1);
	typedef R result;
	typedef _0 arg0;
	typedef _1 arg1;
	static const int narg = 2;
	struct typemask_t {
		char s[ narg + 2 ];
	};
	static typemask_t gettypemask() {
		typemask_t tm = {'t',gettypeflag((_0*)0),gettypeflag((_1*)0),'\0'};
		return tm;
	}
};
template<typename R,typename _0,typename _1,typename _2>
struct functrait<R(*)(_0,_1,_2)> {
	typedef R(*type)(_0,_1,_2);
	typedef R result;
	typedef _0 arg0;
	typedef _1 arg1;
	typedef _2 arg2;
	static const int narg = 3;
	struct typemask_t {
		char s[ narg + 2 ];
	};
	static typemask_t gettypemask() {
		typemask_t tm = {'t',gettypeflag((_0*)0),gettypeflag((_1*)0),gettypeflag((_2*)0),'\0'};
		return tm;
	}
};

template<typename T,typename R>
struct functrait<R(T::*)()> {
	typedef R(T::*type)();
	typedef R result;
	static const int narg = 0;
	struct typemask_t {
		char s[ narg + 2 ];
	};
	static typemask_t gettypemask() {
		typemask_t tm = {'x','\0'};
		return tm;
	}
};
template<typename T,typename R,typename _0>
struct functrait<R(T::*)(_0)> {
	typedef R(T::*type)(_0);
	typedef R result;
	typedef _0 arg0;
	static const int narg = 1;
	struct typemask_t {
		char s[ narg + 2 ];
	};
	static typemask_t gettypemask() {
		typemask_t tm = {'x',gettypeflag((_0*)0),'\0'};
		return tm;
	}
};
template<typename T,typename R,typename _0,typename _1>
struct functrait<R(T::*)(_0,_1)> {
	typedef R(T::*type)(_0,_1);
	typedef R result;
	typedef _0 arg0;
	typedef _1 arg1;
	static const int narg = 2;
	struct typemask_t {
		char s[ narg + 2 ];
	};
	static typemask_t gettypemask() {
		typemask_t tm = {'x',gettypeflag((_0*)0),gettypeflag((_1*)0),'\0'};
		return tm;
	}
};
template<typename T,typename R,typename _0,typename _1,typename _2>
struct functrait<R(T::*)(_0,_1,_2)> {
	typedef R(T::*type)(_0,_1,_2);
	typedef R result;
	typedef _0 arg0;
	typedef _1 arg1;
	typedef _2 arg2;
	static const int narg = 3;
	struct typemask_t {
		char s[ narg + 2 ];
	};
	static typemask_t gettypemask() {
		typemask_t tm = {'x',gettypeflag((_0*)0),gettypeflag((_1*)0),gettypeflag((_2*)0),'\0'};
		return tm;
	}
};

template<typename T,typename R>
struct functrait<R(T::*)() const> : functrait<R(T::*)()>
{
	typedef R(T::*type)() const;
};
template<typename T,typename R,typename _0>
struct functrait<R(T::*)(_0) const> : functrait<R(T::*)(_0)>
{
	typedef R(T::*type)(_0) const;
};
template<typename T,typename R,typename _0,typename _1>
struct functrait<R(T::*)(_0,_1) const> : functrait<R(T::*)(_0,_1)>
{
	typedef R(T::*type)(_0,_1) const;
};
template<typename T,typename R,typename _0,typename _1,typename _2>
struct functrait<R(T::*)(_0,_1,_2) const> : functrait<R(T::*)(_0,_1,_2)>
{
	typedef R(T::*type)(_0,_1,_2) const;
};

#endif

