//	shive's code 2008.09.08
//=============================================================================

static const char* getvalue( HSQUIRRELVM hvm, int index, const char** ) {
	const char* x;
	_(sq_getstring(hvm,index+2,&x));
	return x;
}
static int getvalue( HSQUIRRELVM hvm, int index, int* ) {
	int x;
	_(sq_getinteger(hvm,index+2,&x));
	return x;
}
static float getvalue( HSQUIRRELVM hvm, int index, float* ) {
	float x;
	_(sq_getfloat(hvm,index+2,&x));
	return x;
}
static bool getvalue( HSQUIRRELVM hvm, int index, bool* ) {
	bool x;
	_(sq_getbool(hvm,index+2,&x));
	return x;
}

static void pushresult( HSQUIRRELVM hvm, const char* value ) {
	sq_pushstring(hvm,value,-1);
}
static void pushresult( HSQUIRRELVM hvm, int value ) {
	sq_pushinteger(hvm,value);
}
static void pushresult( HSQUIRRELVM hvm, float value ) {
	sq_pushfloat(hvm,value);
}
static void pushresult( HSQUIRRELVM hvm, bool value ) {
	sq_pushbool(hvm,value);
}

template<typename X>
struct fn;

#define THISCALL(FUNC)											\
	struct fn<FUNC> {											\
		static int call( HSQUIRRELVM hvm ) {					\
			T* p = 0;											\
			_(sq_getinstanceup(hvm,1,(SQUserPointer*)&p,0));	\
			typename functrait<FUNC>::type f = 0;				\
			sq_getuserpointer(hvm,-1,(void**)&f);				\
			return call_and_return(hvm,f,p);					\
		}														\
	}
#define STATICCALL(FUNC)										\
	struct fn<FUNC> {											\
		static int call( HSQUIRRELVM hvm ) {					\
			typename functrait<FUNC>::type f = 0;				\
			sq_getuserpointer(hvm,-1,(void**)&f);				\
			return call_and_return(hvm,f);						\
		}														\
	}

#define DECL_ARG0 ()
#define DECL_ARG1 (_0)
#define DECL_ARG2 (_0,_1)
#define DECL_ARG3 (_0,_1,_2)

#define GET_ARG0 ()
#define GET_ARG1 (getvalue(hvm,0,(_0*)0))
#define GET_ARG2 (getvalue(hvm,0,(_0*)0),getvalue(hvm,1,(_0*)0))
#define GET_ARG3 (getvalue(hvm,0,(_0*)0),getvalue(hvm,1,(_0*)0),getvalue(hvm,2,(_0*)0))

#define TMPL_V_ARG0
#define TMPL_V_ARG1 template<typename _0>
#define TMPL_V_ARG2 template<typename _0,typename _1>
#define TMPL_V_ARG3 template<typename _0,typename _1,typename _2>

#define TMPL_R_ARG0 template<typename R>
#define TMPL_R_ARG1 template<typename R,typename _0>
#define TMPL_R_ARG2 template<typename R,typename _0,typename _1>
#define TMPL_R_ARG3 template<typename R,typename _0,typename _1,typename _2>

TMPL_V_ARG0 static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG0, T* p ) { (p->*f)GET_ARG0; return 0; }
TMPL_V_ARG0 static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG0 const, T* p ) { (p->*f)GET_ARG0; return 0; }
TMPL_V_ARG0 static int call_and_return( HSQUIRRELVM hvm, void(*f)DECL_ARG0 ) { (*f)GET_ARG0; return 0; }
TMPL_R_ARG0 static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG0, T* p ) { pushresult(hvm,(p->*f)GET_ARG0); return 1; }
TMPL_R_ARG0 static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG0 const, T* p ) { pushresult(hvm,(p->*f)GET_ARG0); return 1; }
TMPL_R_ARG0 static int call_and_return( HSQUIRRELVM hvm, R(*f)DECL_ARG0 ) { pushresult(hvm,(*f)GET_ARG0); return 1; }

TMPL_V_ARG1 static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG1, T* p ) { (p->*f)GET_ARG1; return 0; }
TMPL_V_ARG1 static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG1 const, T* p ) { (p->*f)GET_ARG1; return 0; }
TMPL_V_ARG1 static int call_and_return( HSQUIRRELVM hvm, void(*f)DECL_ARG1 ) { (*f)GET_ARG1; return 0; }
TMPL_R_ARG1 static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG1, T* p ) { pushresult(hvm,(p->*f)GET_ARG1); return 1; }
TMPL_R_ARG1 static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG1 const, T* p ) { pushresult(hvm,(p->*f)GET_ARG1); return 1; }
TMPL_R_ARG1 static int call_and_return( HSQUIRRELVM hvm, R(*f)DECL_ARG1 ) { pushresult(hvm,(*f)GET_ARG1); return 1; }

TMPL_V_ARG2 static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG2, T* p ) { (p->*f)GET_ARG2; return 0; }
TMPL_V_ARG2 static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG2 const, T* p ) { (p->*f)GET_ARG2; return 0; }
TMPL_V_ARG2 static int call_and_return( HSQUIRRELVM hvm, void(*f)DECL_ARG2 ) { (*f)GET_ARG2; return 0; }
TMPL_R_ARG2 static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG2, T* p ) { pushresult(hvm,(p->*f)GET_ARG2); return 1; }
TMPL_R_ARG2 static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG2 const, T* p ) { pushresult(hvm,(p->*f)GET_ARG2); return 1; }
TMPL_R_ARG2 static int call_and_return( HSQUIRRELVM hvm, R(*f)DECL_ARG2 ) { pushresult(hvm,(*f)GET_ARG2); return 1; }

TMPL_V_ARG3 static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG3, T* p ) { (p->*f)GET_ARG3; return 0; }
TMPL_V_ARG3 static int call_and_return( HSQUIRRELVM hvm, void(T::*f)DECL_ARG3 const, T* p ) { (p->*f)GET_ARG3; return 0; }
TMPL_V_ARG3 static int call_and_return( HSQUIRRELVM hvm, void(*f)DECL_ARG3 ) { (*f)GET_ARG3; return 0; }
TMPL_R_ARG3 static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG3, T* p ) { pushresult(hvm,(p->*f)GET_ARG3); return 1; }
TMPL_R_ARG3 static int call_and_return( HSQUIRRELVM hvm, R(T::*f)DECL_ARG3 const, T* p ) { pushresult(hvm,(p->*f)GET_ARG3); return 1; }
TMPL_R_ARG3 static int call_and_return( HSQUIRRELVM hvm, R(*f)DECL_ARG3 ) { pushresult(hvm,(*f)GET_ARG3); return 1; }

TMPL_R_ARG0 THISCALL(R(T::*)DECL_ARG0);
TMPL_R_ARG0 THISCALL(R(T::*)DECL_ARG0 const);
TMPL_R_ARG0 STATICCALL(R(*)DECL_ARG0);

TMPL_R_ARG1 THISCALL(R(T::*)DECL_ARG1);
TMPL_R_ARG1 THISCALL(R(T::*)DECL_ARG1 const);
TMPL_R_ARG1 STATICCALL(R(*)DECL_ARG1);

TMPL_R_ARG2 THISCALL(R(T::*)DECL_ARG2);
TMPL_R_ARG2 THISCALL(R(T::*)DECL_ARG2 const);
TMPL_R_ARG2 STATICCALL(R(*)DECL_ARG2);

TMPL_R_ARG3 THISCALL(R(T::*)DECL_ARG3);
TMPL_R_ARG3 THISCALL(R(T::*)DECL_ARG3 const);
TMPL_R_ARG3 STATICCALL(R(*)DECL_ARG3);

#undef THISCALL
#undef STATICCALL

#undef DECL_ARG0
#undef DECL_ARG1
#undef DECL_ARG2
#undef DECL_ARG3

#undef GET_ARG0
#undef GET_ARG1
#undef GET_ARG2
#undef GET_ARG3

#undef TMPL_V_ARG0
#undef TMPL_V_ARG1
#undef TMPL_V_ARG2
#undef TMPL_V_ARG3

#undef TMPL_R_ARG0
#undef TMPL_R_ARG1
#undef TMPL_R_ARG2
#undef TMPL_R_ARG3

