﻿using System;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Text;
using seg;
using seg.lang;

namespace app
{
	static class Program
	{
		/// <summary>
		/// アプリケーションのメイン エントリ ポイントです。
		/// </summary>
		[STAThread]
		static void Main()
		{
			SEG.Init();
			//SEG.TraceHandler = _tracehandler;
			SEG.Trace(SEG.VersionStr);

			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault( false );
			Application.Run( new Form1() );
			
			GC.Collect();
			GC.WaitForPendingFinalizers();
			SEG.Uninit();
		}

		static void _tracehandler( string message )
		{
			Console.Write(message);
		}
	}
}
