#pragma once

namespace seg { namespace dgr {

	class SEGEXPORT Gadget
	{
	public:
		static void Init();
		static void Uninit();

		static void DrawPoint( const Vector& pos, Color color );
		static void DrawLine( const Vector& src, const Vector& trg, Color color );
		static void DrawLineStrip( const Vector* pos, int count, Color color );
		
		static void DrawGrid( const Vector& center, int tile, float scale );
	};

}}
