#pragma once
#include "../Object.h"

namespace seg { namespace dgr {

	class Screen;

	//T[tFCX
	class SEGEXPORT Surface : public Object
	{
	public:
		Surface( IDirect3DSurface9* surf ) : surface_( surf )
		{
		}
		virtual ~Surface()
		{
			if( this->surface_ ){
				this->surface_->Release();
				this->surface_ = 0;
			}
		}

		operator IDirect3DSurface9* () const
		{
			return this->surface_;
		}
		IDirect3DSurface9* operator -> () const
		{
			return this?this->surface_:0;
		}

	private:
		IDirect3DSurface9* surface_;

		friend class Screen;
	};

}}
