#pragma once
#include "../Object.h"

namespace seg { namespace dgr {

	class SEGEXPORT Texture : public Object
	{
	public:
		Texture( IDirect3DBaseTexture9* texture )
		{
			this->texture_ = texture;
		}
		virtual ~Texture()
		{
			if( this->texture_ ){
				this->texture_->Release();
				this->texture_ = 0;
			}
		}

		operator IDirect3DBaseTexture9* () const {
			return this?this->texture_:0;
		}

	private:
		IDirect3DBaseTexture9* texture_;
	};

}}
