
#ifndef _WIN32_WINNT
#define _WIN32_WINNT WINVER
#endif
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include "seg/seg.h"

using namespace seg;

int main( int argc, const char** argv )
{
	(void)argc;
	(void)argv;

	static const int TracePort = 42810;

	socket::init();

	const int TIMEOUT = 500;
	char buf[ 4096 ];
	int len = 0;
	for(;;){
		len = socket::recvfrom(TracePort,buf,sizeof(buf)-1,TIMEOUT);
		if( len == socket::TIMEOUTED ){
			continue;
		}
		if( len < 0 ){
			break;//G[I
		}
		buf[len] = '\0';
		printf(buf);
	}
	
	socket::uninit();
	return 0;
}
