
#pragma once
#pragma warning(push)
#pragma warning(disable:4251)//templateexportĂ

#ifndef DLLEXPORT
# define DLLEXPORT
# define DLLIMPORT __declspec(dllimport)
# define DLLAPI DLLIMPORT
#else
# define DLLIMPORT
# define DLLAPI DLLEXPORT
#endif

#include <memory>

extern "C" {

	DLLEXPORT void c_func();

	struct c_structure {

		int a;
		short b;
		char c;
		char d;

	};

	DLLEXPORT void c_init( c_structure* data );

	DLLAPI extern c_structure s_structure;

}

DLLEXPORT void cpp_func();

class DLLAPI noncopyable {
protected:
	noncopyable(){}
private:
	explicit noncopyable(const noncopyable&){}
	noncopyable& operator=(const noncopyable&){return *this;}
};

class DLLAPI cpp_class : noncopyable {
public:
	cpp_class();
	~cpp_class();

	static std::auto_ptr<cpp_class>& singleton() {
		return s_singleton;
	}

private:
	struct Info;
	static std::auto_ptr<cpp_class> s_singleton;
	c_structure value_;
	std::auto_ptr<Info> info_;
};

#pragma warning(pop)
