
#pragma once
#pragma warning(push)
#pragma warning(disable:4251)//templateexportĂ

#ifndef DLL_EXPORT
#define DLL_EXPORT __declspec(dllexport)
#endif

#include <memory>

extern "C" {

	DLL_EXPORT void c_func();

	struct c_structure {

		int a;
		short b;
		char c;
		char d;

	};

	DLL_EXPORT void c_init( c_structure* data );

	DLL_EXPORT extern c_structure s_structure;

}

DLL_EXPORT void cpp_func();

class DLL_EXPORT noncopyable {
protected:
	noncopyable(){}
private:
	explicit noncopyable(const noncopyable&){}
	noncopyable& operator=(const noncopyable&){return *this;}
};

class DLL_EXPORT cpp_class : noncopyable {
public:
	cpp_class();
	~cpp_class();

	static std::auto_ptr<cpp_class>& singleton() {
		return s_singleton;
	}

private:
	struct Info;
	static std::auto_ptr<cpp_class> s_singleton;
	c_structure value_;
	std::auto_ptr<Info> info_;
};

#pragma warning(pop)
