
#pragma once

#include <memory>

#ifndef DLL_EXPORT
#define DLL_EXPORT __declspec(dllexport)
#endif

extern "C" {

	DLL_EXPORT extern void lib_func();
	DLL_EXPORT extern void lib_func2();

	DLL_EXPORT extern char lib_buf[ 256 ];

}

DLL_EXPORT extern void lib_func3();

namespace lib {

DLL_EXPORT extern char lib_buf_cpp[ 256 ];

#pragma warning(disable:4251)
class DLL_EXPORT lib_class
{
public:
	lib_class();
	virtual ~lib_class();

	virtual void func();
	static std::auto_ptr<lib_class>& get(){
		return s_singleton;
	}

//private:
	static std::auto_ptr<lib_class> s_singleton;
};

}
