
#define DLL_EXPORT __declspec(dllimport)

#include <stdio.h>
#include "lib3.h"
#include "../lib/lib.h"
#include "../lib/libB.h"

void lib3_func()
{
	printf("call lib3_func()\n");
}
void lib3_func2()
{
	printf("call lib3_func2()\n");
}
void lib3_func3()
{
	printf("call lib3_func3()\n");
	printf("%s\n",lib_buf);
	printf("%s\n",libB_buf);
	printf("%s\n",lib::lib_buf_cpp);
}

std::auto_ptr<lib3::lib3_class> lib3::lib3_class::s_singleton;

lib3::lib3_class::lib3_class()
{
	printf("call lib3_class.ctor\n");

	lib3_class::s_singleton.release();
	lib3_class::s_singleton.reset(this);
}
lib3::lib3_class::~lib3_class()
{
	printf("call lib3_class.dtor\n");
	lib3_class::s_singleton.release();
}
void lib3::lib3_class::func()
{
	printf("call lib3_class.func()\n");
}
