/*
	see copyright notice in squirrel.h
*/
#include "sqpcheader.h"

static void *x_sq_vm_malloc(SQUnsignedInteger size){	return malloc(size); }

static void *x_sq_vm_realloc(void *p, SQUnsignedInteger oldsize, SQUnsignedInteger size){ return realloc(p, size); }

static void x_sq_vm_free(void *p, SQUnsignedInteger size){	free(p); }

sq_vm_malloc_t sq_vm_malloc = x_sq_vm_malloc;
sq_vm_realloc_t sq_vm_realloc = x_sq_vm_realloc;
sq_vm_free_t sq_vm_free = x_sq_vm_free;

